## snap7 1.4.2+dfsg

=== build/windows/MinGW32/Makefile ===
#               
# MinGW 32 makefile
#
# Change vars MINGW and MINREL in accord to your compiler path/release
#                
MINGW    =C:/MinGW32
MINREL   =4.7.2
#
#
CPP      = g++.exe
CC       = gcc.exe
TEMP     =../../temp
OBJ      = $(TEMP)/win32/snap_msgsock.o $(TEMP)/win32/snap_sysutils.o $(TEMP)/win32/snap_tcpsrvr.o $(TEMP)/win32/snap_threads.o $(TEMP)/win32/s7_client.o $(TEMP)/win32/s7_isotcp.o $(TEMP)/win32/s7_micro_client.o $(TEMP)/win32/s7_partner.o $(TEMP)/win32/s7_peer.o $(TEMP)/win32/s7_server.o $(TEMP)/win32/s7_text.o $(TEMP)/win32/snap7_libmain.o
LINKOBJ  = $(TEMP)/win32/snap_msgsock.o $(TEMP)/win32/snap_sysutils.o $(TEMP)/win32/snap_tcpsrvr.o $(TEMP)/win32/snap_threads.o $(TEMP)/win32/s7_client.o $(TEMP)/win32/s7_isotcp.o $(TEMP)/win32/s7_micro_client.o $(TEMP)/win32/s7_partner.o $(TEMP)/win32/s7_peer.o $(TEMP)/win32/s7_server.o $(TEMP)/win32/s7_text.o $(TEMP)/win32/snap7_libmain.o
LIBS     = -L"$(MINGW)/lib" -static-libgcc --no-export-all-symbols --add-stdcall-alias $(MINGW)/lib/libws2_32.a $(MINGW)/lib/libwinmm.a $(MINGW)/lib/gcc/mingw32/$(MINREL)/libstdc++.a 
INCS     = -I"$(MINGW)/include" -I"../../../src/sys" -I"../../../src/core" -I"../../../src/lib"
CXXINCS  = -I"$(MINGW)/include" -I"../../../src/sys" -I"../../../src/core" -I"../../../src/lib"
OUTPATH  = ../../bin/Legacy/win32/
DLL      = snap7.dll
OUTLIB   = $(OUTPATH)snap7.lib
BIN      = $(OUTPATH)$(DLL)
CXXFLAGS = $(CXXINCS) -DBUILDING_DLL=1 -Ofast -pedantic
CFLAGS   = $(INCS) -DBUILDING_DLL=1
RM       = rm -f

.PHONY: all all-before all-after clean clean-custom

all: all-before $(BIN) all-after

DLLWRAP=dllwrap.exe
DLLTOOL=dlltool.exe
DEFFILE=$(OUTPATH)snap7.def

clean: clean-custom
	${RM} $(OBJ) $(BIN) $(OUTLIB) $(DEFFILE)

$(BIN): $(LINKOBJ)
	$(DLLWRAP) --output-def $(DEFFILE) --driver-name c++ $(LINKOBJ) $(LIBS) -o $(BIN)

$(TEMP)/win32/snap_msgsock.o: ../../../src/sys/snap_msgsock.cpp
	$(CPP) -c ../../../src/sys/snap_msgsock.cpp -o $(TEMP)/win32/snap_msgsock.o $(CXXFLAGS)

$(TEMP)/win32/snap_sysutils.o: ../../../src/sys/snap_sysutils.cpp
	$(CPP) -c ../../../src/sys/snap_sysutils.cpp -o $(TEMP)/win32/snap_sysutils.o $(CXXFLAGS)

$(TEMP)/win32/snap_tcpsrvr.o: ../../../src/sys/snap_tcpsrvr.cpp
	$(CPP) -c ../../../src/sys/snap_tcpsrvr.cpp -o $(TEMP)/win32/snap_tcpsrvr.o $(CXXFLAGS)

$(TEMP)/win32/snap_threads.o: ../../../src/sys/snap_threads.cpp
	$(CPP) -c ../../../src/sys/snap_threads.cpp -o $(TEMP)/win32/snap_threads.o $(CXXFLAGS)

$(TEMP)/win32/s7_client.o: ../../../src/core/s7_client.cpp
	$(CPP) -c ../../../src/core/s7_client.cpp -o $(TEMP)/win32/s7_client.o $(CXXFLAGS)

$(TEMP)/win32/s7_isotcp.o: ../../../src/core/s7_isotcp.cpp
	$(CPP) -c ../../../src/core/s7_isotcp.cpp -o $(TEMP)/win32/s7_isotcp.o $(CXXFLAGS)

$(TEMP)/win32/s7_micro_client.o: ../../../src/core/s7_micro_client.cpp
	$(CPP) -c ../../../src/core/s7_micro_client.cpp -o $(TEMP)/win32/s7_micro_client.o $(CXXFLAGS)

$(TEMP)/win32/s7_partner.o: ../../../src/core/s7_partner.cpp
	$(CPP) -c ../../../src/core/s7_partner.cpp -o $(TEMP)/win32/s7_partner.o $(CXXFLAGS)

$(TEMP)/win32/s7_peer.o: ../../../src/core/s7_peer.cpp
	$(CPP) -c ../../../src/core/s7_peer.cpp -o $(TEMP)/win32/s7_peer.o $(CXXFLAGS)

$(TEMP)/win32/s7_server.o: ../../../src/core/s7_server.cpp
	$(CPP) -c ../../../src/core/s7_server.cpp -o $(TEMP)/win32/s7_server.o $(CXXFLAGS)

$(TEMP)/win32/s7_text.o: ../../../src/core/s7_text.cpp
	$(CPP) -c ../../../src/core/s7_text.cpp -o $(TEMP)/win32/s7_text.o $(CXXFLAGS)

$(TEMP)/win32/snap7_libmain.o: ../../../src/lib/snap7_libmain.cpp
	$(CPP) -c ../../../src/lib/snap7_libmain.cpp -o $(TEMP)/win32/snap7_libmain.o $(CXXFLAGS)
	
all-after:
	$(DLLTOOL) -D $(DLL) -d $(DEFFILE) -l $(OUTLIB)

=== build/windows/MinGW64/Makefile ===
#
# MinGW 64 makefile 
#
# Change vars MINGW and MINREL in accord to your compiler path/release
#
MINGW    =C:/MinGW64
MINREL   =4.7.1
#
#
CPP      = g++.exe
CC       = gcc.exe
TEMP     =../../temp
OBJ      = $(TEMP)/win64/snap_msgsock.o $(TEMP)/win64/snap_sysutils.o $(TEMP)/win64/snap_tcpsrvr.o $(TEMP)/win64/snap_threads.o $(TEMP)/win64/s7_client.o $(TEMP)/win64/s7_isotcp.o $(TEMP)/win64/s7_micro_client.o $(TEMP)/win64/s7_partner.o $(TEMP)/win64/s7_peer.o $(TEMP)/win64/s7_server.o $(TEMP)/win64/s7_text.o $(TEMP)/win64/snap7_libmain.o
LINKOBJ  = $(TEMP)/win64/snap_msgsock.o $(TEMP)/win64/snap_sysutils.o $(TEMP)/win64/snap_tcpsrvr.o $(TEMP)/win64/snap_threads.o $(TEMP)/win64/s7_client.o $(TEMP)/win64/s7_isotcp.o $(TEMP)/win64/s7_micro_client.o $(TEMP)/win64/s7_partner.o $(TEMP)/win64/s7_peer.o $(TEMP)/win64/s7_server.o $(TEMP)/win64/s7_text.o $(TEMP)/win64/snap7_libmain.o
LIBS     = -L"$(MINGW)/x86_64-w64-mingw32/lib" -static-libgcc --no-export-all-symbols --add-stdcall-alias $(MINGW)/x86_64-w64-mingw32/lib/libws2_32.a $(MINGW)/x86_64-w64-mingw32/lib/libwinmm.a $(MINGW)/lib/gcc/x86_64-w64-mingw32/$(MINREL)/libstdc++.a 
INCS     = -I"$(MINGW)/x86_64-w64-mingw32/include" -I"../../../src/sys" -I"../../../src/core" -I"../../../src/lib"
CXXINCS  = -I"$(MINGW)/x86_64-w64-mingw32/include" -I"../../../src/sys" -I"../../../src/core" -I"../../../src/lib"
OUTPATH  = ../../bin/Legacy/win64/
DLL      = snap7.dll
OUTLIB   = $(OUTPATH)snap7.lib
BIN      = $(OUTPATH)$(DLL)
CXXFLAGS = $(CXXINCS) -DBUILDING_DLL=1 -Ofast -pedantic
CFLAGS   = $(INCS) -DBUILDING_DLL=1 -Ofast -pedantic
RM       = rm -f

.PHONY: all all-before all-after clean clean-custom

all: all-before $(BIN) all-after

DLLWRAP=dllwrap.exe
DLLTOOL=dlltool.exe
DEFFILE=$(OUTPATH)snap7.def

clean: clean-custom
	${RM} $(OBJ) $(BIN) $(OUTLIB) $(DEFFILE)

$(BIN): $(LINKOBJ)
	$(DLLWRAP) --output-def $(DEFFILE) --driver-name c++ $(LINKOBJ) $(LIBS) -o $(BIN)

$(TEMP)/win64/snap_msgsock.o: ../../../src/sys/snap_msgsock.cpp
	$(CPP) -c ../../../src/sys/snap_msgsock.cpp -o $(TEMP)/win64/snap_msgsock.o $(CXXFLAGS)

$(TEMP)/win64/snap_sysutils.o: ../../../src/sys/snap_sysutils.cpp
	$(CPP) -c ../../../src/sys/snap_sysutils.cpp -o $(TEMP)/win64/snap_sysutils.o $(CXXFLAGS)

$(TEMP)/win64/snap_tcpsrvr.o: ../../../src/sys/snap_tcpsrvr.cpp
	$(CPP) -c ../../../src/sys/snap_tcpsrvr.cpp -o $(TEMP)/win64/snap_tcpsrvr.o $(CXXFLAGS)

$(TEMP)/win64/snap_threads.o: ../../../src/sys/snap_threads.cpp
	$(CPP) -c ../../../src/sys/snap_threads.cpp -o $(TEMP)/win64/snap_threads.o $(CXXFLAGS)

$(TEMP)/win64/s7_client.o: ../../../src/core/s7_client.cpp
	$(CPP) -c ../../../src/core/s7_client.cpp -o $(TEMP)/win64/s7_client.o $(CXXFLAGS)

$(TEMP)/win64/s7_isotcp.o: ../../../src/core/s7_isotcp.cpp
	$(CPP) -c ../../../src/core/s7_isotcp.cpp -o $(TEMP)/win64/s7_isotcp.o $(CXXFLAGS)

$(TEMP)/win64/s7_micro_client.o: ../../../src/core/s7_micro_client.cpp
	$(CPP) -c ../../../src/core/s7_micro_client.cpp -o $(TEMP)/win64/s7_micro_client.o $(CXXFLAGS)

$(TEMP)/win64/s7_partner.o: ../../../src/core/s7_partner.cpp
	$(CPP) -c ../../../src/core/s7_partner.cpp -o $(TEMP)/win64/s7_partner.o $(CXXFLAGS)

$(TEMP)/win64/s7_peer.o: ../../../src/core/s7_peer.cpp
	$(CPP) -c ../../../src/core/s7_peer.cpp -o $(TEMP)/win64/s7_peer.o $(CXXFLAGS)

$(TEMP)/win64/s7_server.o: ../../../src/core/s7_server.cpp
	$(CPP) -c ../../../src/core/s7_server.cpp -o $(TEMP)/win64/s7_server.o $(CXXFLAGS)

$(TEMP)/win64/s7_text.o: ../../../src/core/s7_text.cpp
	$(CPP) -c ../../../src/core/s7_text.cpp -o $(TEMP)/win64/s7_text.o $(CXXFLAGS)

$(TEMP)/win64/snap7_libmain.o: ../../../src/lib/snap7_libmain.cpp
	$(CPP) -c ../../../src/lib/snap7_libmain.cpp -o $(TEMP)/win64/snap7_libmain.o $(CXXFLAGS)

all-after:
	$(DLLTOOL) -D $(DLL) -d $(DEFFILE) -l $(OUTLIB)

=== debian/changelog ===
snap7 (1.4.2+dfsg-1) unstable; urgency=medium

  * Initial packaging for Debian based upon Gijs Molenaar's PPA:
    https://github.com/gijzelaerr/snap7-debian
    https://launchpad.net/~gijzelaar/+archive/ubuntu/snap7
    Closes: #1070244

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 02 May 2024 13:28:13 +0200

=== debian/control ===
Source: snap7
Priority: optional
Maintainer: Gijs Molenaar <gijs@pythonic.nl>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.2
Section: libs
Homepage: http://snap7.sourceforge.net/
Vcs-Git: https://salsa.debian.org/debian/snap7.git
Vcs-Browser: https://salsa.debian.org/debian/snap7
Rules-Requires-Root: no

Package: libsnap7-1
Architecture: any
Replaces: libsnap71
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Siemens S7 PLCs communications library
 The new CPUs 1200/1500 and SINAMICS Drives are also partially supported.
 Although it has been designed to overcome the limitations of OPC servers when
 transferring large amounts of high speed data in industrial facilities, it
 scales well down to small Linux based arm boards such as Raspberry PI,
 BeagleBone Black, pcDuino and CubieBoard.
 .
 Three specialized components, Client, Server and Partner, allow you to
 definitively integrate your PC based systems into a PLC automation chain.
 .
 Main features:
  * Native multi-architecture design (32/64 bit).
  * Platform independent, currently are supported Windows (from NT 4.0 up
    to Windows 8), Linux, BSD, Oracle Solaris 11.
  * Fully scalable, starting from blade servers down to Raspberry PI board.
  * No dependence on any third-party libraries, no installation needed, zero
    configuration.
  * Three Different native thread models for performance optimization: Win32
    threads/ Posix threads / Solaris 11 threads.
  * Two data transfer models: classic synchronous and asynchronous.
  * Two data flow models: polling and unsolicited (PLC transfers data when it
    wants to).

Package: libsnap7-dev
Section: libdevel
Architecture: any
Depends: libsnap7-1 (= ${binary:Version}), ${misc:Depends}
Description: Siemens S7 PLCs communications library -- dev files
 The new CPUs 1200/1500 and SINAMICS Drives are also partially supported.
 Although it has been designed to overcome the limitations of OPC servers when
 transferring large amounts of high speed data in industrial facilities, it
 scales well down to small Linux based arm boards such as Raspberry PI,
 BeagleBone Black, pcDuino and CubieBoard.
 .
 Three specialized components, Client, Server and Partner, allow you to
 definitively integrate your PC based systems into a PLC automation chain.\
 .
 Main features:
  * Native multi-architecture design (32/64 bit).
  * Platform independent, currently are supported Windows (from NT 4.0 up
    to Windows 8), Linux, BSD, Oracle Solaris 11.
  * Fully scalable, starting from blade servers down to Raspberry PI board.
  * No dependence on any third-party libraries, no installation needed, zero
    configuration.
  * Three Different native thread models for performance optimization: Win32
    threads/ Posix threads / Solaris 11 threads.
  * Two data transfer models: classic synchronous and asynchronous.
  * Two data flow models: polling and unsolicited (PLC transfers data when it
    wants to).
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS+=hardening=+all

make_opts = DEB_HOST_GNU_CPU=${DEB_HOST_GNU_CPU} DEB_HOST_ARCH_OS=${DEB_HOST_ARCH_OS} \
	    CXX=${DEB_HOST_GNU_TYPE}-g++ LinkerName=$(DEB_HOST_GNU_TYPE)-g++ \
	    SharedObjectLinkerName="${DEB_HOST_GNU_TYPE}-g++ -shared -fPIC -Wl,-soname,libsnap7.so.1"

%:
	dh $@ --sourcedirectory=build/unix

override_dh_auto_build:
	dh_auto_build --sourcedirectory=build/unix -- ${make_opts} all

override_dh_auto_install:
	dh_auto_install --sourcedirectory=build/unix -- ${make_opts}
	mv debian/tmp/usr/lib/libsnap7.so debian/tmp/usr/lib/libsnap7.so.1

execute_after_dh_auto_clean:
	rm -f build/bin/
	rm -rf build/temp/$(DEB_HOST_GNU_CPU)

=== debian/tests/control ===
Test-Command: cd examples/plain-c/x86_64-linux/ && make all clean
Depends: build-essential, @

=== debian/watch ===
version=4
# qa.debian.org runs a redirector which allows a simpler form of URL
# for SourceForge based projects. The format below will automatically
# be rewritten to use the redirector.
opts=repacksuffix=+dfsg,dversionmangle=auto,repack,compression=xz \
http://sf.net/snap7/snap7-full-@ANY_VERSION@@ARCHIVE_EXT@
